#include <windows.h>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <shlwapi.h>
#include <map>
#include <vector>
#include <list>
#include <algorithm>
#include "Utility.h"

bool UtilGetTemporaryFileName(std::string &strName,LPCTSTR prefix)
{
	TCHAR TempDirPath[_MAX_PATH+1]={0};
	GetTempPath(_MAX_PATH,TempDirPath);
	TCHAR fname[_MAX_PATH+1];
	if(!GetTempFileName(TempDirPath,prefix,0,fname)){
		return false;
	}
	strName=fname;
	return true;
}

//t@CۂƁA͎w肳ꂽƂ܂œǂݍ(-1Ŋۂ)
bool UtilReadFile(LPCTSTR lpFile,std::vector<char> &cReadBuffer)
{
	if(!lpFile)return false;
	if(!PathFileExists(lpFile))return false;

	//Open
	HANDLE hFile=CreateFile(lpFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)return false;

	//4GBzt@C͈Ȃ̂Ńt@CTCY擾͂ł悢
	DWORD dwSize=GetFileSize(hFile,NULL);

	cReadBuffer.resize(dwSize);
	DWORD dwRead,dwIndex=0;
	//---ǂݍ
/*	ꊇǂݍ݂̃R[h
	if(!ReadFile(hFile,&cReadBuffer[0],dwSize,&dwRead,NULL)||dwSize!=dwRead){
		CloseHandle(hFile);
		return false;
	}*/
	while(true){
		const DWORD BLOCKSIZE=1024*10;	//10KBƂɓǂݍ
		DWORD readsize=BLOCKSIZE;
		if(dwIndex+readsize>dwSize){
			readsize=dwSize-dwIndex;
		}
		if(!ReadFile(hFile,&cReadBuffer[dwIndex],readsize,&dwRead,NULL)){
			CloseHandle(hFile);
			return false;
		}
		dwIndex+=dwRead;
		if(readsize<BLOCKSIZE)break;	//ǂݐ؂
	}
	CloseHandle(hFile);

	if(dwSize!=dwIndex){
		return false;
	}

	return true;
}



//t@CǂݎAsƂɐ؂蕪ăXgɂ
bool UtilReadFileSplitted(LPCTSTR lpFile,std::list<std::string> &r_LineList)
{
	//sobt@NA
	r_LineList.clear();

	//---ǂݍ
	std::vector<char> cReadBuffer;
	if(!UtilReadFile(lpFile,cReadBuffer))return false;
	//I[0ǉ
	cReadBuffer.resize(cReadBuffer.size()+2);
	cReadBuffer[cReadBuffer.size()-1];
	cReadBuffer[cReadBuffer.size()-2];

	LPCSTR p=&cReadBuffer[0];
	const LPCSTR end=p+_tcslen(p)+1;
	//
	std::string strLine;
	for(;p!=end;p++){
		if(*p==_T('\n')||*p==_T('\r')||*p==_T('\0')){
			if(!strLine.empty()){
				r_LineList.push_back(strLine);
			}
			strLine.clear();
		}
		else 
			strLine+=*p;
	}
	return true;
}

//tH_t@C(fBNg͏)ċA
bool UtilRecursiveEnumFile(LPCTSTR lpszRoot,std::vector<std::string> &rFileList)
{
	WIN32_FIND_DATA cFindFile;
	TCHAR szPath[_MAX_PATH+1];
	_tcsncpy_s(szPath,lpszRoot,_MAX_PATH);
	PathAddBackslash(szPath);
	std::string dirname=szPath;
	PathAppend(szPath,_T("*"));

	HANDLE hFind=FindFirstFile(szPath,&cFindFile);
	if(hFind != INVALID_HANDLE_VALUE){
		BOOL bContinue=TRUE;
		while(bContinue){
			if(0!=strcmp(cFindFile.cFileName,".") && 0!=strcmp(cFindFile.cFileName,"..")){
				if(cFindFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
					UtilRecursiveEnumFile((dirname+cFindFile.cFileName).c_str(),rFileList);
				}else{
					rFileList.push_back(dirname+cFindFile.cFileName);
				}
			}
			bContinue=FindNextFile(hFind,&cFindFile);
		}
		FindClose(hFind);
	}

	return !rFileList.empty();
}
